<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item :label="t('score.productTitle')" prop="title">
        <el-input
          v-model="queryParams.title"
          :placeholder="t('score.pleaseEnterTheProductTitle')"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> {{t('common.search')}}</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> {{t('common.reset')}}</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['score:product:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> {{t('action.add')}}
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column :label="t('score.productTitle')" align="center" prop="title" />
      <el-table-column :label="t('score.productCategory')" align="center" prop="cateName" />
      <el-table-column :label="t('score.mainPicture')" align="center" prop="image" >
        <template #default="score">
          <el-image style="width: 100px; height: 100px" :src="score.row.image"  />
        </template>
      </el-table-column>
      <el-table-column :label="t('score.pointsConsumption')" align="center" prop="score" />
      <el-table-column :label="t('score.price')" align="center" prop="price" />
      <el-table-column :label="t('score.originalPrice')" align="center" prop="otPrice" />
      <el-table-column :label="t('score.weight')" align="center" prop="weigh" />
      <el-table-column :label="t('score.inventory')" align="center" prop="stock" />
      <el-table-column :label="t('score.salesVolume')" align="center" prop="sales" />
      <el-table-column :label="t('score.whetherItIsOnTheShelfOrNot')" align="center" prop="isSwitch">
        <template #default="score">
          <span v-if="score.row.isSwitch == 1">{{ t('public.up') }}</span>
          <span v-else>{{ t('public.down') }}</span>
         </template>
      </el-table-column>
      <el-table-column
        :label="t('public.addTime')"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="170"
      />
      <el-table-column :label="t('public.operate')" align="center" fixed="right" width="150">
        <template #default="score">
          <el-button
            link
            type="primary"
            @click="openForm('update', score.row.id)"
            v-hasPermi="['score:product:update']"
          >
          {{t('action.edit')}}
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(score.row.id)"
            v-hasPermi="['score:product:delete']"
          >
            {{ t('public.delete') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <ProductForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts" name="ScoreProduct">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as ProductApi from '@/api/score/product'
import ProductForm from './ProductForm.vue'
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  title: null,
  image: null,
  images: null,
  desc: null,
  score: null,
  weigh: null,
  stock: null,
  sales: null,
  switch: null,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await ProductApi.getProductPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ProductApi.deleteProduct(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await ProductApi.exportProduct(queryParams)
    download.excel(data, t('score.pointsProductsXls'))
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
